
<p>Evo nam novog primjera. Zamislimo digitalni sklop koji na ulazu dobiva jedan broj (označimo ga s <i>a</i>) a na svojem izlazu (označimo ga s <i>y</i>) daje njegov sljedbenik. Neka pri tome vrijednosti koje može poprimiti broj <i>a</i> budu iz skupa {0, 1, 2, 3, 4, 5, 6, 7}.</p>

<p>Sljedbenik od cijelog broja \(x\) je broj \(x+1\), pa smo zadatak mogli postaviti i ovako: želimo digitalni sklop koji na ulazu dobiva cijeli broj \(x\) a na izlazu daje broj izračunat prema izrazu \(x+1\). Kako ostvariti takav digitalni sklop?</p>

<p>Razmislite najprije u čemu je osnovna razlika između sklopa iz ovog primjera i sklopa iz prethodnog primjera.</p>

<p>Jeste? Odgovor bi trebao biti na sljedećem tragu: u prethodnom primjeru sklop je generirao jedan bit. U ovom primjeru sklop mora generirati više od jednog bita. Naime, na apstraktnoj razini, elementi domene su cijeli brojevi {0, 1, 2, 3, 4, 5, 6, 7}. Kodomenu ove funkcije čine cijeli brojevi {1, 2, 3, 4, 5, 6, 7, 8}. Uz ovako definiranu domenu i kodomenu, funkcija koju razmatramo je bijektivna.</p>

<p>Što će biti ulazi a što izlazi digitalnog sklopa? Za reprezentaciju cijelih brojeva od 0 do 7 prirodnim binarnim kodom trebamo tri bita. Ulaz sklopa stoga će biti uređena trojka (<i>a</i><sub>2</sub>,<i>a</i><sub>1</sub>,<i>a</i><sub>0</sub>) odnosno trobitni vektor <i>a</i><sub>2</sub><i>a</i><sub>1</sub><i>a</i><sub>0</sub>. Za reprezentaciju cijelih brojeva od 1 do 8 prirodnim binarnim kodom trebamo četiri bita. Stoga će izlaz sklopa biti uređena četvorka (<i>y</i><sub>3</sub>,<i>y</i><sub>2</sub>,<i>y</i><sub>1</sub>,<i>y</i><sub>0</sub>) odnosno četverobitni vektor <i>y</i><sub>3</sub><i>y</i><sub>2</sub><i>y</i><sub>1</sub><i>y</i><sub>0</sub>.</p>

<p>Booleova funkcija koju ostvaruje ovaj sklop na binarnoj je razini funkcija \(y: \mathbb{B}^3 \rightarrow \mathbb{B}^4\). Interesantno, na toj razini funkcija nije bijekcija: ne postoji niti jedan element domene koji bi se preslikao primjerice u element (1,1,1,1) kodomene. Grafički prikaz zadane funkcije dan je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(sljedbenik.svg)" alt="Funkcija x na x+1." border="0">
<figcaption>Grafički prikaz funkcije \(y: \mathbb{B}^3 \rightarrow \mathbb{B}^4\) koja preslikava \(a \rightarrow a+1\).</figcaption>
</figure>

<p>Prikaz digitalnog sklopa koji ima ovako definirano sučelje prema okolini dan je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(sljedbenik2.svg)" alt="Prikaz sučelja digitalnog sklopa. Svi ulazi i izlazi su binarni podatci." border="0">
<figcaption>Prikaz sučelja digitalnog sklopa. Svi ulazi i izlazi su binarni podatci.</figcaption>
</figure>

<p>Ponašanje ovog sklopa, baš kao što smo napravili i s prethodnim, formalno možemo opisati tako da odredimo Booleovu funkciju koju sklop ostvaruje. Ovaj sklop ima tri binarna ulaza: <i>a</i><sub>2</sub>, <i>a</i><sub>1</sub> i <i>a</i><sub>0</sub>, te četiri binarna izlaza: <i>y</i><sub>3</sub>, <i>y</i><sub>2</sub>, <i>y</i><sub>1</sub> i <i>y</i><sub>0</sub>. Za uređenu trojku bitova na ulazu sklop generira uređenu četvorku bitova na izlazu. Ovo je primjer općenitije definicije Booleove funkcije (što ćemo na ovom kolegiju zvati višeizlaznom Booleovom funkcijom). Svaka od četiri komponente izlaza predstavljaju po jednu Booleovu funkciju u užem smislu (gdje je kodomena isključivo \(\mathbb{B}\)).</p>

<p>Tablica istinitosti ove funkcije prikazana je u nastavku. Tablica je interaktivna: kliknite na bilo koji redak tablice i vrijednosti ulaza i izlaza koje su dane u tom retku preslikat će se i na sklop prikazan lijevo od tablice.</p>


    <canvas id="myCanvas" width="750" height="290" style="margin-left: auto; margin-right: auto; display: block;"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 3,
        outvars: 4,
        elems: [[0,0,0,0,1,0,0,0,1],[0,0,1,1,2,0,0,1,0],[0,1,0,2,3,0,0,1,1],[0,1,1,3,4,0,1,0,0],[1,0,0,4,5,0,1,0,1],[1,0,1,5,6,0,1,1,0],[1,1,0,6,7,0,1,1,1],[1,1,1,7,8,1,0,0,0]],
        labels: ["a2","a1","a0","a","a+1","y3","y2","y1","y0"],
        outlabels: ["y3","y2","y1","y0"],
        verticals: [1,2,2,1,1,1,2,2,2,1],
        userInput: [-1,-1,-1,-1,-1,-1,-1,-1],
        hots: []
      };

      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            state.currentRow = h.row;
            draw(canvas, context, state);
            break;
          }
        }
      }, false);

      function draw(canvas, context, state) {
        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw circuit...

        var cloff = 100; var ctoff = 40; var cvertOut = 20; var cvertBetween = 50; var choriz = 100; var connector = 20;

        var cheightLeft = 2*cvertOut + (state.vars-1)*cvertBetween;
        var cheightRight = 2*cvertOut + (state.outvars-1)*cvertBetween;
        var cheight = Math.max(cheightLeft,cheightRight);

        var coffl = (cheight-cheightLeft)/2;
        var coffr = (cheight-cheightRight)/2;

        context.beginPath();
        context.strokeStyle = '#000000';
        for(var v = 0; v < state.vars; v++) {
          context.moveTo(cloff, ctoff+coffl+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+coffl+cvertOut+v*cvertBetween);
        }
        for(var v = 0; v < state.outvars; v++) {
          context.moveTo(cloff + connector + choriz, ctoff+coffr+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector + choriz + connector, ctoff+coffr+cvertOut+v*cvertBetween);
        }
        context.stroke();

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();


        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';
        context.textBaseline = 'middle';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.strokeText(state.labels[v], cloff + connector + 2, ctoff+coffl+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.strokeText(''+state.elems[state.currentRow][v], cloff - 2, ctoff+coffl+cvertOut+v*cvertBetween);
        }
        for(var v = 0; v < state.outvars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'right';
          context.strokeText(state.outlabels[v], cloff + connector + choriz - 2, ctoff+coffr+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'left';
          context.strokeText(''+state.elems[state.currentRow][state.labels.length-state.outlabels.length+v], cloff + connector + choriz + connector + 2, ctoff+coffr+cvertOut+v*cvertBetween);
        }

        // Draw table...

        var rh = 30; var toff = 10; var loff = 340; var cw = 50;

        context.beginPath();
        context.strokeStyle = '#000000';
        context.rect(0, 0, canvas.width, canvas.height);
        context.stroke();

        var fontSize = 14;
        context.font = 'normal '+fontSize+'pt Calibri';

        var cws = [];
        var cwsCumul = [];
        for(var i = 0; i < state.labels.length; i++) {
          var actw = context.measureText(state.labels[i]).width;
          var curr = actw+20;
          cws.push(curr);
          cwsCumul.push(i==0 ? curr : curr + cwsCumul[i-1]);
        }
        var tableWidth = cwsCumul[state.labels.length-1];

        loff = canvas.width - tableWidth - 10;

        context.beginPath();
        context.rect(loff, toff, tableWidth, rh);
        context.fillStyle = '#cccccc';
        context.fill();

        context.beginPath();
        context.rect(loff, toff+(state.currentRow+1)*rh, tableWidth, rh);
        context.fillStyle = 'yellow';
        context.fill();

        context.strokeStyle = '#ff0000';
        for(var y = 0; y <= state.elems.length+1; y++) {
          context.lineWidth = (y<2||y==state.elems.length+1) ? 3 : 1;
          context.beginPath();
          context.moveTo(loff, y*rh+toff);
          context.lineTo(loff+tableWidth, y*rh+toff);
          context.stroke();
        }
        for(var x = 0; x <= state.elems[0].length; x++) {
          var left = x==0 ? 0 : cwsCumul[x-1];
          if(state.verticals[x]!=2) {
            context.lineWidth = (state.verticals[x]==0) ? 1 : 3;
            context.setLineDash(state.verticals[x]==0 ? [2,2] : []);
            context.beginPath();
            context.moveTo(loff+left, toff);
            context.lineTo(loff+left, (state.elems.length+1)*rh+toff);
            context.stroke();
          }
        }

        context.setLineDash([]);
        context.lineWidth = 1;

        context.textAlign = 'center';
        context.textBaseline = 'bottom';
        state.hots.length = 0;

        function handler(x,y,w,h,state,row) {
          this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row;
        }

        for(var y = 0; y < state.elems.length+1; y++) {
          if(y>0) {
            state.hots.push(new handler(loff,y*rh+toff,tableWidth,rh,state,y-1));
          }
          for(var x = 0; x < state.elems[0].length; x++) {
            var txt = y==0 ? state.labels[x] : ''+state.elems[y-1][x];
            var middle = x==0 ? cws[0]/2 : cwsCumul[x-1]+cws[x]/2;
            context.strokeText(txt, loff+middle, (y+1)*rh+toff-(rh-fontSize)/4);
          }
        }

      }

      draw(canvas, context, state);

      function getQuestionData() {
        return state.userInput[0]+"."+state.userInput[1]+"."+state.userInput[2]+"."+state.userInput[3];
      }
    </script>

<p>Prva tri stupca navode sve elemente domene: to su uređene trojke bitova. Četvrti stupac dekodira binarne kombinacije ulaza: govori nam (u semantičkom smislu) što smo zapravo doveli na konceptualni ulaz sklopa: koju vrijednost ima broj <i>a</i>. Peti stupac prikazuje koliko iznosi broj <i>a</i> uvećan za jedan. Konačno, posljednja četiri stupca tablice u svakom retku sadrže uređenu četvorku u koju funkcija <i>y</i> mora preslikati uređenu trojku koja se nalazi u tom retku. Ta vrijednost kodira izračunati <i>a</i>+1 prirodnim binarnim kodom.</p>

<p>Čista tablica istinitosti (bez pomoćnih stupaca) prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica istinitosti funkcije \(y(a_2,a_1,a_0)\).</div>
<table class="mlTableCC mlTableVRl4">
<thead><tr><th>\(a_2\)</th><th>\(a_1\)</th><th>\(a_0\)</th><th>\(y_3\)</th><th>\(y_2\)</th><th>\(y_1\)</th><th>\(y_0\)</th></tr></thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>0</td><td>1</td></tr>
<tr><td>0</td><td>0</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td><td>0</td><td>0</td><td>1</td><td>1</td></tr>
<tr><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td><td>1</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>1</td><td>1</td><td>0</td><td>0</td><td>0</td></tr>
</tbody>
</table>

<p>U nastavku ćemo Vas pitati da napišete tablicu istinitosti za sličan sklop pa je važno da dobro razumijete što smo napravili na ovoj stranici. Ako je potrebno, prođite još jednom kroz ovaj primjer.</p>


